#!/usr/bin/bash

FILE="$1"
EXPLICIT="$2"

mkdir -p ~/Temporary/cpalien-testcases

if [ -z $FILE ]
then
  echo "Need a C file"
  exit 1
fi

IFILE=`mktemp`

if ! cpp $FILE -Itest/programs/cpalien >$IFILE
then
  echo "Preprocessing failed: exiting"
  rm -f $IFILE
  exit 1
fi

echo -n "=== Running CPAlien ==="
./scripts/cpa.sh -config ./config/CPAlien.properties $IFILE

if [ -z $EXPLICIT ]
then
  exit
fi
echo -e "\n\n=== Running CPAlien with Explicit ==="
echo "(...press something...)"
read
./scripts/cpa.sh -config ./config/CPAlien-with-explicitAnalysis.properties $IFILE

rm -f ~/Temporary/cpalien-testcases/*
cp $IFILE ~/Temporary/cpalien-testcases/failure.i

rm -f $IFILE
