#!/usr/bin/bash

WORKITEM="$1"

questionTask(){
  local QUESTION="$1"
  local COMMAND="$2"
  echo -n "$QUESTION ? [Y/n]: "
  read ANSWER
  if [ "$ANSWER" == "y" ] || [ "$ANSWER" == "Y" ] || [ -z "$ANSWER" ]
  then
    eval "$COMMAND"
  else
    echo "  Okay, skipping"
  fi
}

questionTask "Rebuild" "ant clean; ant build"
questionTask "Run ant tests" "ant tests"
questionTask "Run testsuite" "scripts/benchmark.py test/test-sets/cpalien.xml"
questionTask "Run broken testsuite parts" "scripts/benchmark.py test/test-sets/cpalien-broken.xml"
questionTask "Run unsound testsuite parts" "scripts/benchmark.py test/test-sets/cpalien-unsound.xml"
questionTask "Run SVCOMP testsuite parts" "scripts/benchmark.py test/test-sets/cpalien-svcomp.xml"

rm -f output/smg-*.{dot,svg}

if [ -z "$WORKITEM" ]
then
  LAST_WI="$(head -n 1 test/programs/cpalien/cpalien-not-yet.set )"
  if [ -n "$LAST_WI" ]
  then
    DEF_WI="${LAST_WI##*/}"
  fi
  echo -n "Please provide a workitem [${DEF_WI:-none}]: "
  read WORKITEM
fi

if [ -z "$WORKITEM" ]
then
  WORKITEM="$DEF_WI"
fi

if [ -n "$WORKITEM" ]
then
  questionTask "Run on $WORKITEM" "scripts/cpalien-with-cpp.sh test/programs/cpalien/$WORKITEM"
  if [ -n "$( ls output/smg-*.dot )" ]
  then
    questionTask "Look at SMGs" "scripts/browse-smgs.sh output"
  fi
else
  echo "  Okay, skipping"
fi
