#!/bin/bash

REPO="$1"

if [ -z "$REPO" ] || [ ! -d "$REPO" ]
then
  echo "Invalid argument: needs an absolute path to the predator repo"
  exit 1
fi

if [ ! -d test/programs ]
then
  echo "This script should be run from CPAChecker repo"
  exit 1
fi

rm -f test/programs/predator
ln -s "$REPO/tests" test/programs/predator

rm -f test/programs/predator/{forester,predator}.set
echo "predator-regre/test-*.c" > test/programs/predator/predator.set
echo "forester-regre/test-*.c" > test/programs/predator/forester.set

cat config/CPAlien.properties > config/CPAlien-predator.properties
cat config/CPAlien.properties > config/CPAlien-forester.properties

echo "parser.preprocessor=cpp -I$REPO/include/predator-builtins" >> config/CPAlien-predator.properties
echo "parser.preprocessor=cpp -I$REPO/include/forester-builtins" >> config/CPAlien-forester.properties

